http://codeforces.com/problemset/problem/540/C
You play a computer game. Your character stands on some level of a multilevel ice cave. In order to move on forward, you need to descend one level lower and the only way to do this is to fall through the ice.
The level of the cave where you are is a rectangular square grid of n rows and m columns. Each cell consists either from intact or from cracked ice. From each cell you can move to cells that are side-adjacent with yours (due to some limitations of the game engine you cannot make jumps on the same place, i.e. jump from a cell to itself). If you move to the cell with cracked ice, then your character falls down through it and if you move to the cell with intact ice, then the ice on this cell becomes cracked.
Let's number the rows with integers from 1 to n from top to bottom and the columns with integers from 1 to m from left to right. Let's denote a cell on the intersection of the r-th row and the c-th column as (r, c).
You are staying in the cell (r1, c1) and this cell is cracked because you've just fallen here from a higher level. You need to fall down through the cell (r2, c2) since the exit to the next level is there. Can you do this?
The first line contains two integers, n and m (1 ≤ n, m ≤ 500) — the number of rows and columns in the cave description.
Each of the next n lines describes the initial state of the level of the cave, each line consists of m characters "." (that is, intact ice) and "X" (cracked ice).
The next line contains two integers, r1 and c1 (1 ≤ r1 ≤ n, 1 ≤ c1 ≤ m) — your initial coordinates. It is guaranteed that the description of the cave contains character 'X' in cell (r1, c1), that is, the ice on the starting cell is initially cracked.
The next line contains two integers r2 and c2 (1 ≤ r2 ≤ n, 1 ≤ c2 ≤ m) — the coordinates of the cell through which you need to fall. The final cell may coincide with the starting one.
If you can reach the destination, print 'YES', otherwise print 'NO'.
4 6 X...XX ...XX. .X..X. ...... 1 6 2 2
YES
5 4 .X.. ...X X.X. .... .XX. 5 3 1 1
NO
4 7 ..X.XX. .XX..X. X...X.. X...... 2 2 1 6
YES
In the first sample test one possible path is:
After the first visit of cell (2, 2) the ice on it cracks and when you step there for the second time, your character falls through the ice as intended.
题意:
n*m的地图,'X'表示有裂痕的冰块,'.'表示完整的冰块,有裂痕的冰块再被踩一次就会碎掉,完整的冰块被踩一次会变成有裂痕的冰块,
现在告诉起点和终点,问从起点能否走到终点并且使终点的冰块碎掉。不能原地跳。起点和终点可能会在同一个位置。
解题思路:
在只走‘.’的情况下把终点的冰踩碎
输入n*m的矩阵
以及走的开始和终点位置
在开始点,上下左右找‘.’,有就走,并把改点设置为‘X’,走到终点时候,若终点是‘X’则成功。
其他情况都失败。
刚开始用DFS写的超时了,就改成了BFS;
#include <iostream> #include <cstring> #include <cstdio> #include <algorithm> #include <cmath> #include <cstdlib> #include <limits> #include <queue> #include <stack> #include <vector> #include <map> using namespace std; typedef long long LL; #define N 10100 #define INF 0x3f3f3f3f #define PI acos (-1.0) #define EPS 1e-8 #define met(a, b) memset (a, b, sizeof (a)) const int dir[4][2] = {{0, 1}, {0, -1}, {1, 0}, {-1, 0}}; struct node { int x, y; }SA, EN; int n, m; char str[N][N]; void BFS (node SA) { queue <node> que; que.push (SA); while (que.size ()) { SA = que.front (); que.pop (); for (int i=0; i<4; i++) { node p = SA; p.x += dir[i][0]; p.y += dir[i][1]; if (p.x>0 && p.x<=n && p.y>0 && p.y<=m) { if (str[p.x][p.y] == 'X' && p.x == EN.x && p.y == EN.y)//达到结束位置,返回 { puts ("YES"); return; } else if (str[p.x][p.y] == '.') { str[p.x][p.y] = 'X'; que.push (p); } } } } puts ("NO"); } int main () { int sax, say, enx, eny; while (scanf ("%d %d", &n, &m) != EOF) { for (int i=1; i<=n; i++) { getchar (); for (int j=1; j<=m; j++) scanf ("%c", &str[i][j]); } scanf ("%d %d %d %d", &sax, &say, &enx, &eny); SA = (node) {sax, say}, EN = (node) {enx, eny}; BFS (SA); } return 0; }